import math
Eps0=8.854187812813e-12 #permeabilita vakua
E0=1.6021773e-16*int(input("energy in keV"))  #přepočet keV na J
náboj= 1.602176634e-19 #elementární el. náboj
z0=int(input("Atomové číslo iontu" ))
z1=int(input("Atomové číslo prvního prvku "))
z2=int(input("Atomové číslo druhého prvku "))
#z3=int(input("Atomové číslo druhého prvku "))...
e=(math.e)
angle=int(input("Počáteční úhel (0° je normála na vzorek, ve stupních) "))
maxangle=int(input("Konečný úhel (ve stupních) "))
nextangle=int(input("Rozdíl dopadového úhlu mezi jednotlivými snímky(ve stupních)"))
velikost=float(0.005)
rotace=int(input("Azimutální úhel (ve stupních) "))
cellparameterX=int(input("Velikost vzorku v ose X (v nm) "))
cellparameterY=int(input("Velikost vzorku v ose Y (v nm) "))
Xdistance=int(input("Meziatomová vzdálenost v ose X (v nm) "))
mat1directory=input("Adresář - cesta k souboru souřadnic prvního prvku ")
mat2directory=input("Cesta druhého prvku ")
#mat3directory =input("Cesta třetího prvku ")


def cone(zmat):      #Vytvoření stínícího kužele  
        j=1
        anglecone=j*math.pi/180
        #začátek smyčky
        a=(0.04685e-9/(z0**0.23 + zmat**0.23))*0.7
        A=(z0*zmat*náboj**2)/(4*(math.pi)*Eps0*E0*a)
        LogA=math.log(A)
        Logj=math.log(j)
        mocnina=(Logj-LogA*(-0.0094*LogA+0.3647)-4.7334) / (-0.0250*LogA-0.7205)
        d=a*(math.exp(mocnina))
        vzdalenost=math.cos(anglecone)*d*1e9
        poloměr=(math.sin(anglecone)*d)*1e9
        f.write ("cone{<"+str(vzdalenost)+",0,0>, "+str(poloměr))
        j=j+1      
        while 1<j<85.01:               
                anglecone=j*math.pi/180
                Logj=math.log(j)
                mocnina=(Logj-LogA*(-0.0094*LogA+0.3647)-4.7334) / (-0.0250*LogA-0.7205)
                d=a*(math.exp(mocnina))
                vzdalenost=math.cos(anglecone)*d*1e9
                poloměr=(math.sin(anglecone)*d)*1e9
                j=j+1                 
                f.write(",<"+str(vzdalenost)+",0,0>,"+str(poloměr)+" ")
                f.write("texture{ pigment{ color Black}}}"'\r\n')
                f.write ("cone{<"+str(vzdalenost)+",0,0>,"+str(poloměr) )                
        if 85<j<86.01:
                f.write (",< 0,0,0>,0 ")
                f.write("texture{ pigment{ color Black}}}"'\r\n')


while(angle<=maxangle):
    radian=angle*(math.pi)/180
    analangle=radian
    f= open("angle"+str(90+angle)+".pov","w+")
    #Camera
    f.write("camera {orthographic"'\r\n')
    f.write("location <"+str(-2.5*math.sin(analangle))+",  0.0, "+str(2.5*math.cos(analangle))+">"'\r\n')
    f.write("look_at  <0 0, 0>"'\r\n')
    f.write("right x*image_width/image_height"'\r\n')
    f.write("        angle 75 }"'\r\n')
    f.write('#include"colors.inc"''\r\n')
    f.write('#include"stones.inc"''\r\n')
    #soustava-sjednocení ocone a atomů
    f.write("#declare Soustava="'\r\n')   
    f.write("union{   "'\r\n')
    #Ocone-sjednocení jednotlivých segmentů
    f.write("#declare mat1cone=   "'\r\n')
    f.write("union{ "'\r\n')
    cone(z1)
    #konec sjednocení Ocone
    f.write("}"'\r\n')
    #atomy struktury
    f.write("#declare mat1 ="'\r\n')
    f.write(" sphere{<0,0,0>,"+str(velikost)+'\r\n')
    f.write(" texture{ pigment{ color Red}"'\r\n')
    f.write("          }"'\r\n')
    f.write(" }"'\r\n')
    #přesunutí atomů na souřadnice
    y =  open(mat1directory, 'r')  
    for line in y:
        f.write ("object{mat1 translate<" +str(line)+">}")
    #přesunutí kužele na správné místo
    mat1cone= open(mat1directory, 'r')
    for line in mat1cone:
        f.write ("object{mat1cone rotate <0,90,0>rotate <0,"+str(-angle)+",0>rotate <0,0,"+str(-rotace)+">translate<"+str(line)+">}")
    #sjednocení kužele druhého materiálu
    f.write("#declare mat2cone=   "'\r\n')
    f.write("union{ "'\r\n')
    cone(z2)
    #konec sjednocení kužele druhého materiálu
    f.write("}"'\r\n')
    #atomy struktury 2
    f.write("#declare mat2 ="'\r\n')
    f.write(" sphere{<0,0,0>,"+str(velikost)+'\r\n')
    f.write(" texture{ pigment{ color Blue}"'\r\n')
    f.write("          }"'\r\n')
    f.write(" }"'\r\n')
    #přesunutí atomů na souřadnice
    mat2 =  open(mat2directory, 'r')  
    for line in mat2:
        f.write ("object{mat2 translate<" +str(line)+">}")
    #přesunutí kužele na správné místo
    mat2cone= open(mat2directory, 'r')
    for line in mat2cone:
        f.write ("object{mat2cone rotate <0,90,0>rotate <0,"+str(-angle)+",0>rotate <0,0,"+str(-rotace)+">translate<"+str(line)+">}")

#Třetí prvek na povrchu
    #    #sjednocení Hcone
    #f.write("#declare mat3cone=   "'\r\n')
    #f.write("union{ "'\r\n')
    #cone(z3)
    ##konec sjednocení Hcone
    #f.write("}"'\r\n')
    ##atomy struktury
    #f.write("#declare mat3 ="'\r\n')
    #f.write(" sphere{<0,0,0>,"+str(velikost)+'\r\n')
    #f.write(" texture{ pigment{ color Green}"'\r\n')
    #f.write("          }"'\r\n')
    #f.write(" }"'\r\n')
    ##přesunutí atomů na souřadnice
    #mat3 =  open(mat3directory, 'r')  
    #for line in mat3:
    #    f.write ("object{mat3 translate<" +str(line)+">}")
    ##přesunutí kužele na správné místo
    #mat3cone= open(mat3directory, 'r')
    #for line in mat3cone:
    #    f.write ("object{mat3cone rotate <0,90,0>rotate <0,"+str(+angle)+",0>rotate <0,0,"+str(-rotace)+">translate<"+str(line)+">}")
    
#.
#.
#.
    

    #konec sjednocení soustavy
    f.write ("}"'\r\n')

    #soustava v černém
    f.write ("#declare SoustavaBlack="'\r\n')
    f.write ("union{   "'\r\n')
    #sjednocení částí kužele1- černá
    f.write ("#declare mat1Blackcone=   "'\r\n')
    f.write ("union{ "'\r\n')
    cone(z1)
    #konec sjednocení kužele
    f.write ("}"'\r\n')
    #černé atomy mat1
    f.write ("#declare mat1Black ="'\r\n')
    f.write (" sphere{<0,0,0>, 0.00000000000000000005"'\r\n') #velikost atomů periodického prodl. pro simulaci výrazně menší, než vzorku
    f.write (" texture{ pigment{ color Magenta}"'\r\n')
    f.write ("          }"'\r\n')
    f.write (" }"'\r\n')
    mat1Black =  open(mat1directory, 'r')       
    for line in mat1Black:
        f.write ("object{mat1Black translate<" +str(line)+">}")
    #přesunutí černého kužele
    mat1Blackcone= open(mat1directory, 'r')
    for line in mat1Blackcone:
        f.write ("object{mat1Blackcone rotate <0,90,0>rotate <0,"+str(-angle)+",0>rotate <0,0,"+str(-rotace)+">translate<"+str(line)+">}")
    #sjednocení částí kužele2- černá
    f.write ("#declare mat2Blackcone=   "'\r\n')
    f.write ("union{ "'\r\n')
    cone(z2)
    #konec sjednocení kužele druhého materiálu
    f.write("}"'\r\n')
    #atomy struktury
    f.write("#declare mat2Black ="'\r\n')
    f.write(" sphere{<0,0,0>,0.00000000000000005"'\r\n')
    f.write(" texture{ pigment{ color Cyan}"'\r\n')
    f.write("          }"'\r\n')
    f.write(" }"'\r\n')
    #přesunutí atomů na souřadnice
    mat2Black =  open(mat2directory, 'r')  
    for line in mat2Black:
        f.write ("object{mat2Black translate<" +str(line)+">}")
    #přesunutí kužele na správné místo
    mat2Blackcone= open(mat2directory, 'r')
    for line in mat2Blackcone:
        f.write ("object{mat2Blackcone rotate <0,90,0>rotate <0,"+str(-angle)+",0>rotate <0,0,"+str(-rotace)+">translate<"+str(line)+">}")


#3. prvek v periodickém prodloužení
    ##sjednocení Hcone
    #f.write("#declare mat3Blackcone=   "'\r\n')
    #f.write("union{ "'\r\n')
    #cone(1)
    ##konec sjednocení Hcone
    #f.write("}"'\r\n')
    ##atomy struktury
    #f.write("#declare mat3Black ="'\r\n')
    #f.write(" sphere{<0,0,0>,0.0000005"'\r\n')
    #f.write(" texture{ pigment{ color Green}"'\r\n')
    #f.write("          }"'\r\n')
    #f.write(" }"'\r\n')
    ##přesunutí atomů na souřadnice
    #mat3Black =  open(mat3directory, 'r')  
    #for line in mat3Black:
    #    f.write ("object{mat3Black translate<" +str(line)+">}")
    ##přesunutí kužele na správné místo
    #mat3Blackcone= open(mat3directory, 'r')
    #for line in mat3Blackcone:
    #    f.write ("object{mat3Blackcone rotate <0,90,0>rotate <0,"+str(+angle)+",0>rotate <0,0,"+str(-rotace)+">translate<"+str(line)+">}")
    

#.
#.
#.



        
    #konec sjednocení soustavy
    f.write("}"'\r\n')

    #umožnění otáčení
    f.write("#declare toceni="'\r\n')
    f.write("union{"'\r\n')
        
    f.write("object{Soustava  translate      <"+str(cellparameterX/2)+","+str(-cellparameterY/2)+" , 0>}"'\r\n')
    f.write("object{SoustavaBlack  translate <"+str(cellparameterX/2)+","+str(cellparameterY/2)+" , 0>}"'\r\n')
    f.write("object{SoustavaBlack  translate <"+str(cellparameterX/2)+","+str(-cellparameterY/2*3)+",  0>}  "'\r\n')
    f.write("object{SoustavaBlack  translate <"+str((-cellparameterX/2)- Xdistance/2)+","+str(-cellparameterY/2)+",  0>}   "'\r\n')
    f.write("object{SoustavaBlack  translate <"+str((-cellparameterX/2)- Xdistance/2)+","+str(cellparameterY/2)+",  0>}  "'\r\n')
    f.write("object{SoustavaBlack  translate <"+str((-cellparameterX/2)- Xdistance/2)+","+str(-cellparameterY/2*3)+",  0>} "'\r\n')
    f.write("object{SoustavaBlack  translate <"+str((3*cellparameterX+ Xdistance)/2)+","+str(-cellparameterY/2)+",  0>}  "'\r\n')
    f.write("object{SoustavaBlack  translate <"+str((3*cellparameterX+ Xdistance)/2)+","+str(cellparameterY/2)+",  0>} "'\r\n') 
    f.write("object{SoustavaBlack  translate <"+str((3*cellparameterX+ Xdistance)/2)+","+str(-cellparameterY/2*3)+", 0>} "'\r\n')
    f.write("}"'\r\n')
    f.write("object {toceni translate< 0 0 0> rotate<0 0 ,"+str(rotace)+"> }"'\r\n')
           
    angle=angle+nextangle
    f.close()    

    









    


                
